/*
"Tourism" mutator for Unreal 1.

lets you mosey around peacefully, enjoying the world.
any unfriendly monsters that show up will be killed instantly.
worry not, their death is painless.  this is completely ethical.
*/
class Tourism extends Mutator;

function Timer() {
	local Pawn Player, P;
	local bool hit;
	Player = Level.GetLocalPlayerPawn();
	// iterate through the PawnList.  dead pawns are removed, so this will
	// never be prohibitively expensive to be doing twice a second.
	for ( P=Level.PawnList; P!=None; P=P.nextPawn ) {
		if ( P.bIsPlayer )
			continue;
		// we only care about ScriptedPawns, with a few exceptions.
		if ( !P.IsA('ScriptedPawn') && !P.IsA('BiterFish') && !P.IsA('Bloblet') )
			continue;
		// don't kill the Nali or innocent animals, they are our friends.
		if ( P.IsA('Nali') )
			continue;
		if ( P.IsA('Cow') )
			continue;
		// this looks important...
		if ( P.IsA('UPakIntermissionCam') )
			continue;
		
		// kill.
		// wait until we can trace to them, to disrupt level scripting minimally.
		hit = FastTrace(P.Location, Player.Location);
		if ( hit ) {
			P.TakeDamage(P.Default.Health+1, Player, vect(0,0,0), vect(0,0,0), 'shot');
			//Player.ClientMessage("Tourism: killed a "$P);
		}
	}
}

function ModifyPlayer(Pawn Other) {
	// make the player invisible for extra relaxation.
	// bumping into monsters during their brief existence will still aggro them.
	Other.Visibility = 0;
}

function PreBeginPlay() {
	Super.PreBeginPlay();
	SetTimer(0.5, True);
}

function Mutate(string fnff, PlayerPawn Sender) {
	// this doesn't seem to work.
	Sender.ClientMessage("hello!");
}

defaultproperties {

}
